/*
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef SCOPEREGISTRY_SIGNAL_THREAD_H
#define SCOPEREGISTRY_SIGNAL_THREAD_H

#include <unity/util/NonCopyable.h>

#include <mutex>
#include <thread>

#include <sys/types.h>

namespace scoperegistry
{

class SignalThread final
{
public:
    NONCOPYABLE(SignalThread);

    SignalThread();
    ~SignalThread();

    void activate(std::function<void()> callback);
    void stop();

private:
    void wait_for_sigs();

    std::mutex mutex_;
    std::function<void()> callback_;
    bool done_;
    std::thread handler_thread_;
    sigset_t sigs_;
};

} // namespace scoperegistry

#endif
